/**************************************************************
    MegaIrc - The final TTY-Obfuscated Encryption IRC Client
    NO(C)MM MegaBug Industries.

    Authors: megabug (megabug@iname.com)
             c1cc10  (c1cc10@ecn.org)
	     ginox
 **************************************************************
    20/02/2001 Ver. 0.46a
    Compile with: ti piacerebbe saperlo eh? MUORI!
 **************************************************************/

//#define MEGAIRC_VERSION "MegaIRC v0.46a... constantly in upgrading..."
#define MEGAIRC_VERSION "Ma non puoi farti una vagonata di cazzi tuoi?"

#include <arpa/inet.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <netdb.h>
#include <netinet/in.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/poll.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdarg.h>
#include <dlfcn.h> // per il caricamento dinamico di funzioni esterne: shared library, tnx 2 ginox 4 da support & da code ;^)))

#include "Users.h"
#include "NetIO.h"
#include "Obfuscator.h"

#include <FL/Fl_Window.h>
#include <FL/Fl_Box.h>
#include <FL/Fl_Input.h>
#include <FL/Fl_Output.h>
#include <FL/Fl_Multiline_Output.h>
#include <FL/Fl_Menu_Bar.h>
#include <FL/Fl_Menu_Item.h>
#include <FL/Fl_Browser.h>
#include <FL/Fl_Button.h>
#include <FL/Fl_Light_Button.h>
#include <FL/Fl_Hold_Browser.h> 
#include <stdio.h>
#include <string.h>

#define LARGHEZZA 700
#define ALTEZZA 500
#define LARGH_USERS 130
#define ALTEZ_USERS 350
#define LARGH_INPUT (LARGHEZZA - (LARGH_USERS+5))
#define ALTEZ_INPUT 20
#define LARGH_OUTPUT (LARGHEZZA - (LARGH_USERS+5))
#define ALTEZ_OUTPUT 400
#define ALTEZ_MENU 30
#define LARGH_BUTTON 100 
#define ALTEZ_BUTTON 24 

#define MAX_LENGTH_CODE 5 

/* #define per la creazione di finestre di dialogo */
#define CHAN_DLG 30
#define CHAN_TOPIC 31
//#define ALTEZ_MENU 30

void quit( Fl_Widget *, void * );

void chan_join( Fl_Widget *, void * );
void chan_leave( Fl_Widget *, void * );
void chan_topic( Fl_Widget *, void * );

void user_kick_callback( Fl_Widget *, void * );
void user_ban_callback( Fl_Widget *, void * );
void user_deban_callback( Fl_Widget *, void * );
void user_op_callback( Fl_Widget *, void * );
void user_deop_callback( Fl_Widget *, void * );
void user_voice_callback( Fl_Widget *, void * );
void user_devoice_callback( Fl_Widget *, void * );
void make_dlg_windows (int type);
void destroy_dlg_window( Fl_Widget *, void * );
void format_large( Fl_Widget *, void * );
void format_medium( Fl_Widget *, void * );
void format_small( Fl_Widget *, void * );
void help( Fl_Widget *, void * );
void tty_obfuscated( Fl_Widget *, void * );

/* Funzioni per la shared library*/
/* Ora proviamo a caricare obfuscator come shared library yuk yuk!!*/
char *(*encode)(const char *nick, const char *msg);
int *(*is_encoded)(const char *nick, const char *msg);
char *(*decode)(const char *nick, const char *msg);

void *lib_id; // l'identificativo della libreria caricata

/* Finestra principale */
Fl_Window *main_window;

/* Finestra di dialogo base->1 input, pulsante OK e cancella */
/* Questi widget vengono inizializzati in make_dlg_windows, per personalizzarli a piacere*/
Fl_Window *dlg_window;
Fl_Input *dlg_input;
Fl_Button *dlg_button_ok;
Fl_Button *dlg_button_cancel;

/* Creazione e gestione del label di input... */
Fl_Input *main_input;
Fl_Multiline_Output *main_subject;

/* ...Di output... */
Fl_Browser *main_output;
Fl_Hold_Browser *main_utenti;

/* Pulsanti per la comunicazione*/
Fl_Light_Button *button_tty_o;
/* Pulsanti per gestione degli utenti*/
Fl_Button *button_user_op;
Fl_Button *button_user_deop;
Fl_Button *button_user_voice;
Fl_Button *button_user_devoice;
Fl_Button *button_user_kick;
Fl_Button *button_user_ban;
Fl_Button *button_user_deban;

/* Semafori e formattazione */
int tty_obfuscated_mode = 0;

int large;
int medium;
int little;
//int defaultcolor;

/* ...E del menu' */
Fl_Menu_Bar *main_menu;
Fl_Menu_Item menuitems[] = {
	{ "Finestra", 0, 0, 0, FL_SUBMENU }, 
		{ "Chiudi", FL_ALT + 'x', (Fl_Callback *)quit, 0 },
		{0}, 
	{ "Canale", 0, 0, 0, FL_SUBMENU }, 
		{ "Join", FL_ALT + 'j', (Fl_Callback *)chan_join, 0 },
		{ "Leave", FL_ALT + 'l', (Fl_Callback *)chan_leave, 0 },
		{ "Cambia il Topic", FL_ALT + 't', (Fl_Callback *)chan_topic, 0 },
		{0}, 
	{ "Utente", 0, 0, 0, FL_SUBMENU }, 
		{ "Kick", FL_ALT + 'k', (Fl_Callback *)user_kick_callback, 0 },
		{ "Ban", FL_ALT + 'b', (Fl_Callback *)user_ban_callback, 0 },
		{ "DEBan", FL_ALT + 'B', (Fl_Callback *)user_deban_callback, 0 },
		{ "OPpa", FL_ALT + 'o', (Fl_Callback *)user_op_callback, 0 },
		{ "DEOPpa", FL_ALT + 'd', (Fl_Callback *)user_deop_callback, 0 },
		{ "VOICE", FL_ALT + 'v', (Fl_Callback *)user_voice_callback, 0 },
		{ "DEVOICE (silent)", FL_ALT + 's', (Fl_Callback *)user_devoice_callback, 0 },
		{0},
	{ "Formattazione", 0, 0, 0, FL_SUBMENU }, 
		{ "Large", FL_ALT + 'L', (Fl_Callback *)format_large, 0 },
		{ "Medium", FL_ALT + 'M', (Fl_Callback *)format_medium, 0 },
		{ "Small", FL_ALT + 'S', (Fl_Callback *)format_small, 0 },
		{0},
	{ "Help", 0, 0, 0, FL_SUBMENU }, 
		{ "Comandi disponibili", FL_ALT + 'h', (Fl_Callback *)help, 0 },
		{0}, 
	{ "OBFUSCATE!", 0, 0, 0, FL_SUBMENU }, 
		{ "Attiva/Disattiva", FL_ALT + 'O', (Fl_Callback *)tty_obfuscated, 0 },
		{0}, 

	{0}
};



/* Copia la stringa contenuta in src dentro dest fino a raggiungere
 * il carattere di terminazione trigger o '\0'.
 * Restituisce il puntatore al carattere di trigger. */
char *strgetuntil( char *dest, char *src, char trigger )
{
	while ( *src != trigger && *src )
	{
		*dest = *src;
		dest++;
		src++;
	}
	*dest='\0';
	return src;
}


const int DEBUG=0;

char nickname[20] = "megairc";
char channame[20] = "";

Users *users;
//Obfuscator *obfuscator;


int fltkmain( int argc, char **argv );
void termprintf( char *fmt, ... );
void parseconsolecommand( const char *data_in );



/* Definizione dei colori dei messaggi del server */
#define COL_BANNER	""
#define COL_WHOIS_BEGIN	"@C190"
#define COL_WHOIS_LINES	"@C187"
#define COL_WHOIS_END	"@C190"
#define COL_USER_INFO	"@C140"
#define COL_AWAY	"@C150"
#define COL_TOPIC	""
#define COL_JOIN	""
#define COL_MOTD	"@C90"
#define COL_NO_NICK	""
#define COL_NICK_IN_USE	""
#define COL_OTHER	""

void parse_servmsg( char *buffer )
{
	char token[100];
	int id;
	char code[MAX_LENGTH_CODE] = "";

	buffer = strgetuntil( token, buffer, ' ' )+1;
	id = atoi( token );

	#ifdef __AUTISMO__
	sprintf( code, "%d ", id );
	termprintf( "returned code: %s\n", code );
	#endif

	/* Banner (1 2 3 4) */
	if ( id>=1 && id<=3 ) {
		buffer = strgetuntil( token, buffer, ':' )+1;
		termprintf( COL_BANNER "     %s\n", buffer );
		return;
	}
	if ( id==4 ) {
		buffer = strgetuntil( token, buffer, ' ' )+1;
		termprintf( COL_BANNER "     %s\n", buffer );
		return;
	}

	/* Info utenti connessi (251) */
	if ( id==251 ) {
		buffer = strgetuntil( token, buffer, ':' )+1;
		termprintf( COL_USER_INFO "     %s\n", buffer );
		return;
	}
	/* Info operatori online (252) */
	/* Info connessioni unknown (253) */
	/* Info canali formati (254) */
	if ( id>=252 && id<=254 ) {
		int chans;
		buffer = strgetuntil( token, buffer, ' ' )+1;
		buffer = strgetuntil( token, buffer, ' ' )+1;
		chans = atoi( token );
		buffer = strgetuntil( token, buffer, ':' )+1;
		termprintf( COL_USER_INFO "     %d %s\n", chans, buffer );
		return;
	}
	
	/* Info sui client (255) */
	if ( id==255 ) {
		buffer = strgetuntil( token, buffer, ':' )+1;
		termprintf( COL_USER_INFO "     %s\n", code, buffer );
		return;
	}
	
	/* RPL_AWAY: "<nick> :<away message>" */
	if ( id==301 )
	{
		termprintf( COL_AWAY "%s%s\n", code, buffer);
		return;
	}
	
	/* RPL_WHOISUSER: "<nick> <user> <host> * :<real name>" */
	if ( id==311 )
	{
		char nick[300], user[300], host[300], name[300];
		buffer = strgetuntil( token, buffer, ' ' )+1;

		#ifdef __AUTISMO__
		termprintf( "%s<nick> <user> <host> * :<real name>:", code);
		termprintf( "%s", buffer);
		#endif

		/* Ricava i dati dell'utente */
		buffer = strgetuntil( nick, buffer, ' ' )+1;
		buffer = strgetuntil( user, buffer, ' ' )+1;
		buffer = strgetuntil( host, buffer, ' ' )+3;
		buffer = strgetuntil( token, buffer, ':' )+1; strcpy( name, token );
		strcat( name, " " ); strcat( name, buffer );

		termprintf( COL_WHOIS_BEGIN "------------------------------------");
		termprintf( COL_WHOIS_LINES "   %s (%s@%s) Real name: %s", nick, user, host, name );
		return;
	}

	/* RPL_WHOISSERVER: "<nick> <server> :<server info>" */
	if ( id==312 )
	{
		char server[300], info[300];
		buffer = strgetuntil( token, buffer, ' ' )+1;

		#ifdef __AUTISMO__
		termprintf( "<nick> <server> :<server info>\n" );
		termprintf( "%s%s\n", code, buffer);
		#endif

		/* Ricava i dati del server */
		buffer = strgetuntil( token, buffer, ' ' )+1;
		buffer = strgetuntil( server, buffer, ' ' )+2;
		strcpy( info, buffer );

		termprintf( COL_WHOIS_LINES "   Server: %s, %s", server, info );
		return;
	}

	/* RPL_WHOISOPERATOR: "<nick> :is an IRC operator" */
	if ( id==313 )
	{
		buffer = strgetuntil( token, buffer, ':' )+1;
		termprintf( COL_WHOIS_LINES "   %s\n", buffer);
		return;
	}

	/* RPL_WHOISIDLE: "<nick> <integer> :seconds idle" */
	if ( id==317 )
	{
		int secs, mins, hours, days;

		buffer = strgetuntil( token, buffer, ' ' )+1;

		#ifdef __AUTISMO__
		termprintf( "<nick> <integer> :seconds idle\n");
		termprintf( "%s%s\n", code, buffer);
		#endif

		/* Salta la parte col nick */
		buffer = strgetuntil( token, buffer, ' ' )+1;

		/* Legge il numero di secondi in idle */
		buffer = strgetuntil( token, buffer, ' ' )+1;
		days = atoi(token);

		/* Calcola il tempo di idle */
		secs = days % 60;
		days /= 60;
		mins = days % 60;
		days /= 60;
		hours = days % 24;
		days /= 24;

		/* Formatta l'output del messaggio */
		if ( days > 3 ) {
			termprintf( COL_WHOIS_LINES "   Il tipo si e' ammutolito %d giorni fa e sta puzzando:" );
			termprintf( COL_WHOIS_LINES "   Chiama un'ambulanza.");
			return;
		}
		if ( days ) {
			termprintf( COL_WHOIS_LINES "   Il tipo tace da %d giorni, %d ore, %d minuti, %d secondi.", days, hours, mins, secs );
			return;
		}
		if ( hours ) {
			termprintf( COL_WHOIS_LINES "   Il tipo tace da %d ore, %d minuti, %d secondi.\n", hours, mins, secs );
			return;
		}
		if ( mins ) {
			termprintf( COL_WHOIS_LINES "   Il tipo tace da %d minuti, %d secondi.\n", mins, secs );
			return;
		}

		termprintf( COL_WHOIS_LINES "   Il tipo tace da %d secondi.\n", secs );
		return;
	}

	/* RPL_WHOISCHANNELS: "<nick> :*( ( "@" / "+" ) <channel> " " )" */
	if ( id==319 )
	{
		buffer = strgetuntil( token, buffer, ' ' )+1;
							
		#ifdef __AUTISMO__
		termprintf( "%s<nick> :*( ( \"@\" / \"+\" ) <channel>\n", code);
		#endif

		/* Ricava i canali dove e' collegato il tipo */
		buffer = strgetuntil( token, buffer, ':' )+1;

		termprintf( COL_WHOIS_LINES "   E' connesso a: %s\n", buffer);
		return;
	}

	/* RPL_ENDOFWHOIS: "<nick> :End of WHOIS list" */
	if ( id==318 )
	{
		#ifdef __AUTISMO__
		termprintf( "%s%s\n", code, buffer);
		#endif

		termprintf( COL_WHOIS_END "End of WHOIS-------------------------\n");
		return;
	}

	/* Subject (332) */
	if ( id==332 ) {
		buffer = strgetuntil( token, buffer, ':' )+1;
		main_subject->value( buffer );
		return;
	}

	/* Time & User del Subject (333) */
	if ( id==333 ) {
		buffer = strgetuntil( token, buffer, ':' )+1;
		termprintf( COL_TOPIC "     %s\n", buffer );
		return;
	}

	/* Elenco utenti nel canale (353) */
        if ( id==353 ) {
	    
		/* "mynick (=|@|*) #canale :user user user @user +user user..." */

		char chantype;
		
		/* Scarta la prima parte e recupera il tipo di canale */
		buffer = strgetuntil(token, buffer, ' ')+1;
		chantype = *buffer;
		buffer+=2;
		
		/* Recupera il nome del canale */
		buffer = strgetuntil(channame, buffer, ' ')+2;

		/* Cicla tutti gli utenti e gli aggiunge alla lista */
	    	for (;;) {
			while ( *buffer == ' ' ) buffer++;

			/* Se siamo arrivati a fine stringa esci */
			if ( !buffer[0] ) break;
	    		buffer = strgetuntil(token, buffer, ' ');

			if ( token[0]=='@' ) {
				users->add( token+1 );
				users->setop( token+1 );
			} else if ( token[0]=='+' ) {
				users->add( token+1 );
				users->setvoice( token+1 );
			} else
				users->add( token );
	    	}

	    	users->refresh();
	    	return;
	}
	/* Fine dell'elenco degli utenti nel canale (366). trappato per non
	   andare a video*/
        if ( id==366 ) {
		termprintf( COL_JOIN "Ora sei dentro %s...", channame );
		return;
	}

	/* Messaggio MOTD (372 375 376) */
	if ( id==372 || id==375 || id==376 )
		buffer = strgetuntil( token, buffer, ':' )+1;
	if ( id==375 ) {
		termprintf( COL_MOTD "MOTD -> %s\n", buffer );
		return;
	}
	if ( id==372 ) {
		termprintf( COL_MOTD "        %s\n", buffer );
		return;
	}
	if ( id==376 ) {
		termprintf( COL_MOTD "MOTD End.\n" );
		return;
	}
      
	/* ERR_NOSUCHNICK: "<nickname> :No such nick/channel" */
	if ( id==401 )
	{
		termprintf( COL_NO_NICK "Il nick non esiste, tu non esisti." );
		termprintf( COL_NO_NICK "Kallopismata orfnes: ornamento dell'oscurita'." );
		return;
	}
      
	/* Nickname already in use (433) */
	if ( id==433 ) {
		termprintf( COL_NICK_IN_USE "Il Nick e' gia' utilizzato da un altro. Coglione!" );
		return;
	}
	
	/* Messaggio di controllo sconosciuto */
	termprintf( COL_OTHER "UNK Serv.Msg %d > %s\n", id, buffer );
}

void parse( char *buffer )
{
	//termprintf( "NETWORK: %s",buffer );

	/* Verifica se c'e' una sorgente */
	if ( buffer[0]==':' )
	{
		char msg_from[100];
		char nick_from[100];

		/* Ricava la sorgente del messaggio */
		buffer++;
		buffer = strgetuntil( msg_from, buffer, ' ' )+1;
		
		/* E' un messaggio dal server? */
		if ( !strstr( msg_from, "!" ) )
		{

			/* E' un messaggio di controllo? */
			if ( isdigit( *buffer ) )
			{
				parse_servmsg( buffer );
				return;
			}

			termprintf( "UNK Serv.Msg > %s\n", buffer );
			return;
		}

		/* E' un messaggio da un utente */
		/* Ricava l'utente sorgente del messaggio */
		strgetuntil( nick_from, msg_from, '!' );

		/* E' un PRIVMSG? */
		if ( strncmp( buffer, "PRIVMSG", 7 ) == 0 )
		{
			char to[100];

			buffer+=8;
			buffer = strgetuntil( to, buffer, ' ' )+1;
			
			/* Elimina i ':' */
			buffer++;

			/* E' un comando CTCP */
			if ( buffer[0]==1 )
			{
				/* Elimina i ^A all'inizio e alla fine della stringa */
				buffer++;
				buffer[strlen(buffer)-1] = '\0';

				if ( strcmp( "VERSION", buffer ) == 0 )
				{
					char temp[512];
					sprintf( temp, "/notice %s \001VERSION " MEGAIRC_VERSION "\001", nick_from );
					parseconsolecommand( temp );
					termprintf( "@C4[ctcp VERSION from %s] reply sent...", nick_from );
					return;
				}
				if ( strncmp( "ACTION", buffer, 6 ) == 0 )
				{
					/* Facciamo puntare all'inizio dell'action */
					buffer += 7;
					termprintf("@C150%s: %s", nick_from, buffer);
					return;
				}
				termprintf( "[ctcp(%s)] %s\n", nick_from, buffer );
				return;
			}
			
			/* E' veramente un PRIVMSG */

			/* E' un messaggio diretto a noi? */
			if ( strcmp(to, nickname)==0 )
			{
				termprintf( "@C60[msg(%s)] %s\n", nick_from, buffer );
			}
			else
			{
				char msg[1024];
				strncpy( msg, buffer, 1023 );
				msg[1023]='\0';
				(int *) is_encoded = dlsym(lib_id, "is_encoded");	
				(char *) decode = dlsym(lib_id, "decode");	
				
				if ( ((int *) (* is_encoded) ( nick_from, msg )) )
				{
					termprintf( "@C110<%s> %s\n", nick_from, (char *) (*decode) ( nick_from, msg ) );
				}
				else 
					termprintf( "<%s> %s\n", nick_from, msg );
				}
			
			return;
		}

		/* E' un NOTICE? */
		if ( strncmp( buffer, "NOTICE", 6 ) == 0 )
		{
			char to[100];

			buffer+=7;
			buffer = strgetuntil( to, buffer, ' ' )+1;
			
			/* Elimina i ':' */
			buffer++;

			termprintf( "[notice(%s)] %s\n", nick_from, buffer );
			return;
		}

		/* E' un utente che entra nel chan? */
		if ( strncmp( buffer, "JOIN", 4 ) == 0 )
		{
			/* Non aggiungo me stesso */
			if ( strcmp( nick_from, nickname ) == 0 ) return;

			/* Aggiorniamo il nuovo utente */
			users->add( nick_from );

			/* Stampa il messaggio di JOIN dell'utente */
			buffer += 4;
			termprintf( "@C88%s entra a rompere il cazzo in %s.\n", nick_from, buffer);

			/* Aggiorna la lista */
			users->refresh();	
			return;
		}

		/* E' un utente kikkato dal chan? */
		/*KICK #channame nickto :messaggio*/
		if ( strncmp( buffer, "KICK", 4 ) == 0 )
		{
			char to[30];
			char spazzatura[20];
			
			buffer += 5;//Ora punta a #channame
			buffer = strgetuntil(spazzatura, buffer, ' ')+1;
			buffer = strgetuntil(to, buffer, ' ')+1;
			/* Ora to contiene il nick kikkato e buffer il msg*/
			/* Minkia ma sono io?!?! */
			if ( strcmp( to, nickname ) == 0 ) 
			{
				termprintf( "@C2Sei stato appena cacciato a calci da %s: %s\n", nick_from, buffer);
				channame[0]='\0';
				users->clear();
				main_subject->value("");
				users->refresh();
				return;
			}
			/* Elimina l'utente che e' andato via dal canale */
			users->del( to );

			/* Stampa il messaggio di PART dell'utente */
			buffer += 4;
			termprintf( "@C2%s ha appena cacciato a calci in culo %s: %s\n", nick_from, to, buffer);

			/* Aggiorna la lista */
			users->refresh();
			return;
		}
		
		/* E' un utente che lascia il server? */
		if ( strncmp( buffer, "QUIT", 4 ) == 0 )
		{
			/* Elimina l'utente che e' andato via dal canale */
			users->del( nick_from );

			/* Stampa il messaggio di QUIT dell'utente */
			buffer += 4;
			
			termprintf( "@C233%s si e' rotto i maroni e quitta %s\n", nick_from, buffer);

			/* Aggiorna la lista */
			users->refresh();
			return;
		}

		/* E' un utente che lascia il chan? */
		if ( strncmp( buffer, "PART", 4 ) == 0 )
		{
			/* Elimina l'utente che e' andato via dal canale */
			users->del( nick_from );

			/* Stampa il messaggio di PART dell'utente */
			buffer += 4;
			termprintf( "@C111%s esce dalle palle di %s.\n", nick_from, buffer);

			/* Sono io ad essere uscito? */
			if ( strcmp( nick_from, nickname )==0 )
			{
				channame[0]='\0';
				users->clear();
				main_subject->value( "" );
			}

			/* Aggiorna la lista */
			users->refresh();
			return;
		}
		
		/* E' un utente che lascia il server? */
		if ( strncmp( buffer, "QUIT", 4 ) == 0 )
		{
			/* Elimina l'utente che e' andato via dal canale */
			users->del( nick_from );

			/* Stampa il messaggio di QUIT dell'utente */
			buffer += 4;
			
			termprintf( "@C233%s si e' rotto i maroni e quitta: %s\n", nick_from, buffer);

			/* Aggiorna la lista */
			users->refresh();
			return;
		}

		/* E' un utente che cambia nick? */
		if ( strncmp( buffer, "NICK", 4 ) == 0 )
		{
			char to[30];

			buffer += 6; // 6 perche' deve mangiarsi anche i ':'
			strgetuntil( to, buffer, ' ' );
			
			/* Stampa il messaggio di NICK dell'utente */
			termprintf( "@C128%s ha cambiato nick in %s\n", nick_from, to);
			
			/* Rinomina l'utente che e' andato via dal canale */
			users->rename( nick_from, to );

			/* Se sono stato io a cambiare nick rinomina anche la variabile
			   d'ambiente */
			if ( strcmp(nickname, nick_from)==0 )
				strcpy(nickname, to);

			/* Aggiorna la lista */
			users->refresh();
			return;
		}

		/* E' un utente che cambia mode? */
		if ( strncmp( buffer, "MODE", 4 ) == 0 )
		{
			char chan[30];
			char to[30];
			int set;
			char mode;
			
			/* "MODE #canale +o nick" */
			
			/* Recupera il canale */
			buffer += 5;
			buffer = strgetuntil( chan, buffer, ' ' ) + 1;

			/* Vede se si tratta di un set o un unset */
			set = (*buffer=='+') ? 1 : 0;
			buffer++;
			
			/* Vede quale modalita' sta cambiando */
			mode = *buffer;
			buffer+=2;
			
			/* Vede quale nick sta cambiando */
			strgetuntil( to, buffer, ' ' );

			if ( mode=='o' ) {
				if ( set ) {
					users->setop( to );
					termprintf( "@C4%s da i superpoteri a %s.", nick_from, to );
				} else {
					users->unsetop( to );
					termprintf( "@C3%s toglie i superpoteri a %s.", nick_from, to );
				}
			}

			if ( mode=='v' ) {
				if ( set ) {
					users->setvoice( to );
					termprintf( "%s concede la voce a %s.", nick_from, to );
				} else {
					users->unsetvoice( to );
					termprintf( "%s zittisce %s.", nick_from, to );
				}
			}

			users->refresh();
			return;
		}

		/* E' un utente che cambia il topic? */
		if ( strncmp( buffer, "TOPIC", 5 ) == 0 )
		{
			char channel[20];
			
			buffer += 6;
			strgetuntil( channel, buffer, ':' );
			main_subject->value(buffer);
			termprintf("@C233Nuovo topic by: %s", nickname);
		}
		
		termprintf( "%s UNK.Msg> %s\n", nick_from, buffer );
		return;
	}

	/* Se e' un ping rispondi */
	if ( strncmp( buffer, "PING", 4 ) == 0 )
	{
		long numero;
		sscanf( buffer, "PING :%ld", &numero );
		netio.invia( "PONG :%ld\n", numero );
		termprintf( "PING? PONG!\n" );
		return;
	}

	/* Protocollo sconosciuto */
	termprintf( "UNK Protocol Msg. %s\n", buffer );
}





void parseconsolecommand( const char *data_in )
{
	char *buffer;
	buffer = strdup( data_in );
	
	//termprintf( "INPUT: %s", data_in );
	
	/* Comando /MSG <nick> <messaggio> */
	if ( strncasecmp( buffer, "/msg ", 5 ) == 0 )
	{
		char to[100];
		char msg[1024];

		buffer += 5;
		buffer = strgetuntil( to, buffer, ' ' )+1;

		strncpy( msg, buffer, 1023 );
		msg[1023]='\0';
		
		/* Visualizza sul terminale */
		if ( strcmp(to,channame)==0 )
		{
			if ( tty_obfuscated_mode )
				termprintf( "@C110<%s> %s", nickname, msg );
			else
				termprintf( "<%s> %s", nickname, msg );
		} 
		else 
			termprintf( "[PRIVMSG to %s] %s", to, msg );

		if ( tty_obfuscated_mode )
		{
		/* qui si e' fatta + lunga per debugging */
			char *message;
			(char *) encode = dlsym(lib_id, "encode");	
			message = (char *) (*encode)( nickname, msg ); 
			strcpy( msg, message );
		}

		netio.invia( "PRIVMSG %s :%s\n", to, msg );

		return;
	}
	
	/* Comando /NOTICE <nick> <messaggio> */
	if ( strncasecmp( buffer, "/notice ", 8 ) == 0 )
	{
		char to[100];
		buffer += 8;
		buffer = strgetuntil( to, buffer, ' ' )+1;
		netio.invia( "NOTICE %s :%s\n", to, buffer );
		return;
	}

	/* Comando /JOIN <channel> <messaggio> */
	if ( strncasecmp( buffer, "/join ", 6 ) == 0 )
	{
		if ( *channame )
			parseconsolecommand( "/part" );
			
		buffer += 6;
		strcpy(channame, buffer);
		netio.invia( "JOIN %s\n", buffer );
		return;
	}

	/* Comando /KICK <channel> <utente> <messaggio> */
	/* Manca la parte di <messaggio> */
	if ( strncasecmp( buffer, "/kick ", 6 ) == 0 )
	{
		buffer += 6;
		strcpy(channame, buffer);
		netio.invia( "KICK %s %s\n", channame, buffer );
		return;
	}

	/* Comando /NICK <nickname> */
	if ( strncasecmp( buffer, "/nick ", 6 ) == 0 )
	{
		buffer += 6;
		netio.invia( "NICK %s\n", buffer );
		return;
	}

	/* Comando /PART <messaggio> */
	if ( strncasecmp( buffer, "/part", 5 ) == 0 )
	{
		buffer += 5;
		if ( !buffer[0] ) {
			netio.invia( "PART %s :Saluto tutti i cazzoni del canale!\n", channame );
			return;
		}

		buffer++;
		netio.invia( "PART %s :%s\n", channame, buffer );
		return;
	}

	/* Comando /CTCP <nick> <messaggio> */
	if ( strncasecmp( buffer, "/ctcp ", 6 ) == 0 )
	{
		char to[100];
		buffer += 6;
		buffer = strgetuntil( to, buffer, ' ' )+1;
		netio.invia( "PRIVMSG %s :\001%s\001\n", to, buffer );
		return;
	}

	/* Comando /QUIT <messaggio> */
	if ( strncasecmp( buffer, "/quit ", 6 ) == 0 )
	{
		buffer += 6;
		netio.invia( "QUIT %s\n", buffer );
		return;
	}

	/* Comando /TOPIC <messaggio> */
	if ( strncasecmp( buffer, "/topic ", 7 ) == 0 )
	{
		buffer += 7;
		netio.invia( "TOPIC %s :%s\n", channame, buffer );
		return;
	}

	/* Comando /HELP */
	if ( strncasecmp( buffer, "/help", 5 ) == 0 )
	{
		help(NULL,NULL);
		return;
	}
	
	/* Comando /WHOIS */
	if ( strncasecmp( buffer, "/whois", 6 ) == 0 )
	{
		buffer += 6;
		netio.invia( "WHOIS %s\n", buffer );
		return;
	}
	
	termprintf( "Comando sconosciuto. Guarda bene quello che scrivi." );
}


int main( int argc, char **argv )
{
	char servername[100] = "";

	netio.set_parser( parse );

	/* Routine di controllo della riga di comando: */
	/* Strippo dal mitico "cannone"-> un programma mai cagato da niuno 8^(( c1cc10 */
	if (argc > 1) for ( int i=1; i<argc; i++ )
	{
		switch ( argv[i][1] )
		{
			case 'u': case 'U': 	// Nome utente
				strncpy(nickname, argv[++i], 19);
				nickname[19]='\0';
	  			break;
          		case 's': case 'S': 	// Server scelto
	    			strncpy(servername, argv[++i], 99);
				servername[99]='\0';
          			break;
          		case 'c': case 'C': 	// Canale-> Megabuuuug???!?!?!?!?
				fprintf(stderr, "\nSorry: non ancora implementato! Fallo tu, vuoi?\n"); 
				//strncpy(channame, argv[++i], 18);
          			break;
          		case 'h': case 'H': 	// Naturally d help-on-lain. ihihihi
	   			fprintf(stderr, "-u nome utente; -c nome del canale -s nome del server. \n Sinno' va in default su www.ecn.org con nick mega.\n");
	   			exit (0);
          		default: 		// Cazzo di opzioni scrive la gente??
           			fprintf(stderr, "Ma che cazzo di opzione sarebbe -%c ?\n", argv[i][1]); 
           			fprintf(stderr, "Fai -h e guarda cosa puoi scrivere, cazzone!!\n");
           			exit(1);    
      		} // switch
   	} // for & if
	

	/*apro la libreria condivisa, la aggancio come farei con un file*/
	if (!(lib_id = dlopen("./obfuscated.so",RTLD_LAZY)))
		/*in caso di errore dlerror butta fuori una stringa di descrizione*/
	{
		fprintf(stderr,"%s\n", dlerror());
		exit (1);
	}
	else
		fprintf(stderr, "libreria caricata\n");
		

	/* Inizializziamo quello che non e' passato dalle opzioni a riga di comando*/ 
   	if ( !servername[0] )
		netio.connetti( "www.ecn.org", 6667 );
   	else      
		netio.connetti( servername, 6667 );

	netio.invia( "NICK %s\n", nickname );
	netio.invia( "USER %s 0 0 :%s\n", nickname, nickname );
	//netio.invia( "JOIN %s", channame );
	 
	fltkmain( argc, argv );
	exit(0);
	
}
void help( Fl_Widget *, void * )
{
	termprintf( "@C202 Minkia cheppalle!!8^))\n" );
	termprintf( "@C202 Allora siamo quasi in beta (v 0.45a)!! 8^))\n" );
	termprintf( "@C202 Puoi usare");
	termprintf( "@C108 /join, /nick, /whois\n" );
	termprintf( "@C202 poi anche");
	termprintf( "@C108 /topic, /leave \n" );
	termprintf( "@C108 /op /deop /ban /deban"); 
	termprintf( "@C202 ma e' meglio che controlli\n" );
	termprintf( "@C202Se vuoi implementare nuovi comandi (aggratis) faccelo sape'\n" );
}

void quit( Fl_Widget *, void * )
{
	parseconsolecommand("/quit Infedeli!!");
	sleep(1);
	exit(0);
}

void join( Fl_Widget *, void * )
{
 	char messaggio[100] = "/join ";

	strncat( messaggio, dlg_input->value(), 99 );
	messaggio[99]='\0';
	parseconsolecommand(messaggio);
	dlg_window->hide();	
}

void topic( Fl_Widget *, void * )
{
 	char messaggio[100] = "/topic ";

	strncat( messaggio, dlg_input->value(), 99 );
	messaggio[99]='\0';
	parseconsolecommand(messaggio);
	dlg_window->hide();	
}
void destroy_dlg_window( Fl_Widget *, void * )
{
	dlg_window->~Fl_Window();	
}

void make_dlg_window( int type )
{
	if (type == CHAN_DLG){
		dlg_window = new Fl_Window (300, 105, "Entra nel canale");
		dlg_input = new Fl_Input (70, 10, 200, 25, "Canale:");
		dlg_input->when(FL_WHEN_ENTER_KEY);
		dlg_input->callback(join);
		dlg_input->value("#");
		/* Dovrebbe riposizionare il cursore, ma non lo fa! porkoiddio! */
		dlg_input->index(dlg_input->size());
			
		dlg_button_ok = new Fl_Button (10, 70, 90, 25, "Ok");
		dlg_button_ok->callback(join);
		dlg_button_cancel = new Fl_Button (230, 70, 60, 25, "Cancel");
		dlg_button_cancel->callback(destroy_dlg_window);
	
		dlg_window->end();
		dlg_window->show();
			
		return;
	}
	if (type == CHAN_TOPIC){
		dlg_window = new Fl_Window (300, 105, "Cambia il topic");
		dlg_input = new Fl_Input (70, 10, 200, 25, "Topic:");
		dlg_input->when(FL_WHEN_ENTER_KEY);
		dlg_input->callback(topic);
		dlg_input->value(main_subject->value());
		/* Dovrebbe riposizionare il cursore, ma non lo fa! porkoiddio! */
		dlg_input->index(dlg_input->size());
			
		dlg_button_ok = new Fl_Button (10, 70, 90, 25, "Ok");
		dlg_button_ok->callback(topic);
		dlg_button_cancel = new Fl_Button (230, 70, 60, 25, "Cancel");
		dlg_button_cancel->callback(destroy_dlg_window);
	
		dlg_window->end();
		dlg_window->show();
			
		return;
	}}

void tty_obfuscated( Fl_Widget *, void * )
{
	tty_obfuscated_mode = !tty_obfuscated_mode;
	if ( tty_obfuscated_mode )
	{
		termprintf ( "TTY OBFUSCATED attivato." );
		button_tty_o->value(1);
	}
	else
	{
		termprintf ( "TTY OBFUSCATED disattivato." );
		button_tty_o->value(0);
	}
}

void chan_join( Fl_Widget *, void * )
{
	make_dlg_window (CHAN_DLG);
}

void chan_leave( Fl_Widget *, void * )
{
	parseconsolecommand("/part");
}

void chan_topic( Fl_Widget *, void * )
{
	make_dlg_window (CHAN_TOPIC);

//	parseconsolecommand("/topic %s :%s", channame, );
}

void user_kick_callback( Fl_Widget *, void * )
{
	netio.invia( "KICK %s %s\n", channame, users->selected() );
}

void user_ban_callback( Fl_Widget *, void * )
{
	netio.invia( "MODE %s +b %s\n", channame, users->selected() );
}

void user_deban_callback( Fl_Widget *, void * )
{
	netio.invia( "MODE %s -b %s\n", channame, users->selected() );
}

void user_op_callback( Fl_Widget *, void * )
{
	netio.invia( "MODE %s +o %s\n", channame, users->selected() );
} 

void user_deop_callback( Fl_Widget *, void * )
{
	netio.invia( "MODE %s -o %s\n", channame, users->selected() );
} 

void user_voice_callback( Fl_Widget *, void * )
{
	netio.invia( "MODE %s +v %s\n", channame, users->selected() );
} 

void user_devoice_callback( Fl_Widget *, void * )
{
	netio.invia( "MODE %s -v %s\n", channame, users->selected() );
} 

void format_large( Fl_Widget *, void * )
{	
	medium = 0;
	little = 0;
	large = 1;
}

void format_medium( Fl_Widget *, void * )
{
	medium = 1;
	little = 0;
	large = 0;
}

void format_small( Fl_Widget *, void * )
{
	medium = 0;
	little = 1;
	large = 0;
}


/* Scrive data_in sulla finestra di output */
void write_to_terminal( const char *data_in )
{

	/* E a sto giro risolviamo anche il buffer overflow sulla riga di input ;^) */
	char riga_da_mettere_a_video[150] =""; 
	
	if (large)
		main_output->textsize(24);
	
	if (medium)
		main_output->textsize(16);
	
	if (little)
		main_output->textsize(8);

	strncat(riga_da_mettere_a_video, data_in, 149);
	riga_da_mettere_a_video[149]='\0';
	main_output->add( riga_da_mettere_a_video );
	main_output->bottomline( main_output->size() );
}

void termprintf( char *fmt, ... )
{
static	char buff[1024];
	va_list args;

	/* Formatta la stringa passata come parametri */
	va_start( args, fmt );
	vsnprintf( buff, 1023, fmt, args );
	va_end( args );
	buff[1023]='\0';

	/* E la stampa sul terminale */
	write_to_terminal( buff );
}


void writing( Fl_Widget *widget, void *dati )
{
	/* Vediamo di mandare dei messaggi, aggiungendo allo scritto la stringa "/MSG" */
	const char *stringa;
	stringa = main_input->value();

	/* Parsing del messaggio o del comando */ 
   	if (stringa[0] != '/') {
		// Sta scrivendo nel canale
		if ( !channame[0] ) {
			write_to_terminal( "Non sei connesso a nessun canale." );
		} else {
			char buffer[600];
			sprintf( buffer, "/msg %s %s", channame, stringa );
			parseconsolecommand( buffer );
		}
	} else {
		// E' un comando
		parseconsolecommand( stringa );
	}

	main_input->cut();
}

int fltkmain( int argc, char **argv )
{
	/* Inizializziamo i semafori di fomattazione */
	large = 0;
	medium = 0;
	little = 0;
	/* Per chiarezza di codice, inseriamo delle variabili che contengono la posizione
	   dei widget nella finestra. x = larghezza, y = altezza */	
	int subject_y = (ALTEZ_MENU + 3), subject_x = 0; 
	int output_y = (subject_y  + ALTEZ_INPUT + 2), output_x = 0; 
	int input_y = (ALTEZZA - ALTEZ_INPUT - 3), input_x = 0;// + conveniente calcolare la y dal basso, su questo widget 8^) 
	int button_tty_o_y = (output_y + ALTEZ_OUTPUT), button_tty_o_x = 2;
	int users_y = subject_y, users_x = (LARGHEZZA - LARGH_USERS); 
 	
	/* Creiamo ora la finestra ed i suoi widget */
	main_window = new Fl_Window( LARGHEZZA, ALTEZZA, "MegaIRC v.0.45a" );
	main_window->iconlabel("./marcello-2.gif");
	main_menu = new Fl_Menu_Bar(0,0, LARGHEZZA, ALTEZ_MENU);
	main_menu->menu(menuitems);

	main_subject = new Fl_Multiline_Output(subject_x, subject_y, LARGH_INPUT, ALTEZ_INPUT);
	main_subject->textcolor(3);
	/* Nota: 0nero1rosso7/255bianco16grigioverde18grigioantracite */
	main_subject->color(18, 0);
	main_subject->textfont(13);
	main_subject->textsize(13);
        main_output = new Fl_Browser( output_x, output_y, LARGH_OUTPUT, ALTEZ_OUTPUT );
	main_output->color(0, 255);
	main_output->textcolor(255);
	main_input = new Fl_Input( input_x, input_y, LARGH_INPUT, ALTEZ_INPUT, "" );
	main_input->when( FL_WHEN_ENTER_KEY );	// Callback ;^)) I like it man! 
	main_input->callback(writing);
	/*pulsanti per canale e personali*/
	button_tty_o = new Fl_Light_Button(button_tty_o_x, button_tty_o_y , LARGH_BUTTON, ALTEZ_BUTTON, "Obfuscate!");
	button_tty_o->selection_color(FL_GREEN);	
	button_tty_o->callback(tty_obfuscated);	
	/* Creazione e gestione della finestra utenti connessi */
	main_utenti = new Fl_Hold_Browser (users_x, 
			users_y, LARGH_USERS, 
			(ALTEZ_USERS + ALTEZ_INPUT));
	/*pulsanti per la gestione degli utenti*/
	button_user_op = new Fl_Button(users_x, (users_y  + ALTEZ_USERS + 20), 60, 20, "Op");
	button_user_op ->callback(user_op_callback);	
	button_user_deop = new Fl_Button((users_x + 63), (users_y  + ALTEZ_USERS + 20), 60, 20, "DeOp"); 
	button_user_deop ->callback(user_deop_callback);	
	button_user_voice = new Fl_Button(users_x, (users_y  + ALTEZ_USERS + 40), 60, 20, "Voice");  
	button_user_voice ->callback(user_voice_callback);	
	button_user_devoice = new Fl_Button((users_x + 63), (users_y  + ALTEZ_USERS + 40), 60, 20, "DeVoice");   
	button_user_devoice ->callback(user_devoice_callback);	
	button_user_kick = new Fl_Button(users_x, (users_y  + ALTEZ_USERS + 60), 60, 20, "Kick");   
	button_user_kick ->callback(user_kick_callback);	
	button_user_ban = new Fl_Button((users_x + 63), (users_y  + ALTEZ_USERS + 60), 60, 20, "Ban");   
	button_user_ban ->callback(user_ban_callback);	
	button_user_deban = new Fl_Button(users_x, (users_y  + ALTEZ_USERS + 80), 60, 20, "DeBan");    
	button_user_ban ->callback(user_deban_callback);	
	
	main_window->resizable(main_output);
	/*cambia e tiene traccia del colore di foreground per l'intero Widget*/
	/*Utile per ulteriori sviluppi di formattazione dell'output.*/
	//defaultcolor = main_output->textfont();
	//main_output->textcolor(25);
	main_window->end();
	main_window->show();

	/* Inizializza il gestore della lista utenti */
	users = new Users( main_utenti );

	/* Inizializza il gestore del TTY Obfuscated */
	//obfuscator = new Obfuscator( );
		return Fl::run();
}

/**************************************************************
    Allora... visto che ti sei letto il codice fin qui ti
    meriti un premio...

    Compile with:
    c++ -I../ -L../lib -O2 -Wall -I/usr/X11R6/include -fno-exceptions MegaIRC.cxx -lfltk -L/usr/X11R6/lib -lX11 -lXext -lm -o MegaIRC

    che sleppa eh? divertiti (se sei masochista...)!
 **************************************************************/

